hdu 3853 LOOPS 期望dp

Akemi Homura is a Mahou Shoujo (Puella Magi/Magical Girl). 

Homura wants to help her friend Madoka save the world. But because of the plot of the Boss Incubator, she is trapped in a labyrinth called LOOPS. 


The planform of the LOOPS is a rectangle of R*C grids. There is a portal in each grid except the exit grid. It costs Homura 2 magic power to use a portal once. The portal in a grid G(r, c) will send Homura to the grid below G (grid(r+1, c)), the grid on the right of G (grid(r, c+1)), or even G itself at respective probability (How evil the Boss Incubator is)! 
At the beginning Homura is in the top left corner of the LOOPS ((1, 1)), and the exit of the labyrinth is in the bottom right corner ((R, C)). Given the probability of transmissions of each portal, your task is help poor Homura calculate the EXPECT magic power she need to escape from the LOOPS. 


 

Input

The first line contains two integers R and C (2 <= R, C <= 1000). 

The following R lines, each contains C*3 real numbers, at 2 decimal places. Every three numbers make a group. The first, second and third number of the cth group of line r represent the probability of transportation to grid (r, c), grid (r, c+1), grid (r+1, c) of the portal in grid (r, c) respectively. Two groups of numbers are separated by 4 spaces. 

It is ensured that the sum of three numbers in each group is 1, and the second numbers of the rightmost groups are 0 (as there are no grids on the right of them) while the third numbers of the downmost groups are 0 (as there are no grids below them). 

You may ignore the last three numbers of the input data. They are printed just for looking neat. 

The answer is ensured no greater than 1000000. 

Terminal at EOF 

 

Output

A real number at 3 decimal places (round to), representing the expect magic power Homura need to escape from the LOOPS. 
 

Sample Input

2 2
0.00 0.50 0.50    0.50 0.00 0.50
0.50 0.50 0.00    1.00 0.00 0.00

Sample Output

6.000

 

题意:从点 (1,1)出发,可以向右向下和留在原地,概率分别为p1,p2,p3。 问从(1,1)到(R,C)的期望

题解:简单的概率dp。

dp[ i ][ j ] 表示从(i,j)到终点所需期望

dp[i][j]=p1[i][j]*dp[i][j]+p2[i][j]*dp[i][j+1]+p3[i][j]*dp[i+1][j]+2

整理一下得到:

dp[i][j]=p2[i][j]*dp[i][j+1]/(1-p1[i][j])+p3[i][j]*dp[i+1][j]/(1-p1[i][j])+2/(1-p1[i][j])

注意这题有个坑点 ,1-p1[ i ][ j ] 有可能等于零,或者说 无限接近于零,这时候这个点就不能走了。。所以要把这种情况的点排除

#include<bits/stdc++.h>
using namespace std;
double dp[1005][1005];
struct node{
    double x,y,z;
}w[1005][1005];
int n,m;
int main(){
    while(~scanf("%d%d",&n,&m)){
        for(int i = 1; i <= n; i++){
            for(int j = 1; j<= m; j++){
                scanf("%lf%lf%lf",&w[i][j].x,&w[i][j].y,&w[i][j].z);
            }
        }
        memset(dp,0,sizeof(dp));
        dp[n][m] = 0; 
        for(int i = n; i >= 1; i--){
            for(int j = m; j >= 1; j--){
            	if(i == n && j == m) continue;
            	double res = 1 - w[i][j].x; 
            	if(res < 1e-5) continue; //坑点 
                dp[i][j] = dp[i][j+1]*w[i][j].y/res + dp[i+1][j]*w[i][j].z/res + 1.0*2/res;
            }
        }
        printf("%.3lf\n",dp[1][1]);
    }
}

 

评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值